unit lt2n_drawtools_b_u1;

//See "const" declarations for app name and version info
//See http://sheepdogguides.com/lut/lt2n-drawtools-pt2.htm
//   for a guide to what's in this code.

{$mode objfpc}{$H+}

interface

//This builds on lt2n_drawtools_a.

//DrawingTools_A's "DGToolDoDotWWr"
//had FLAW in "wrap" mechanism.
//A less flawed version of that appears
//    in this. By the time you read this,
//    the less flawed version MAY have
//    been retro-fitted to Tools_a
//Note to self: SORT OUT online versions
//    of Tools_a, write up in a's tutorial
//    Already, there is a "patch it" note
//    in the .htm, at least.

//At 22 Dec 2018, I changed project options,
//  compiler options, debugging. Turned OFF
//  "generate debugging info for GDB".
//Said to make compile faster, AND reduce
//  exe size. It did... .exe shrank from 15meg
//  to 1.9meg


(*Is THUS the one to make THE statement of these
  matters? If so, polish. If not, remove!

PUT THING IN AN EASY TO EXPORT form

This, DrawingTools_B, uses, needs what that needed in
//    DrawingTools_A... (write that out) and adds...

  procedure DGToolScrollLeft
  procedure DGToolClearDrawingArea
  function iDGToolYScale
  function extRemap
  procedure Delay

//Now also requires... POLISH: What was always needed, what is new?
//  global object...
 bmDGTool:TBitmap;
//  global variable...
 clDGToolGraphBackGround:TColor;
//     ... which controls the background color for
//     ... the graph. If it changes as the program
//     ... runs, only NEW instances of drawing in
//     ... bacground color have any effect. "Old
//     ... background remains the color it was.

  To build a graph from the right hand edge, with it
    scrolling left until the oldest material falls
    off left hand edge repeatedly something like...

    DGToolDoDotWWr(DGToolDoDotWWr(iDGToolImgWidth-1,
       iDGToolYScale(iTmp,
                     137,224,20,50),RGBToColor(200,120,0));
    DGToolScrollLeft;

In that...
  iDGToolImgWidth is just the global constant use in many
      places within the DrawingTools suites
  iTmp should hold the next value for whatever
      it is you are doing a graph about
  137,224 would be your best guess at the lowest and
      highest values iTmp is going to have
  20,50 mean that IF your iTmp values stick to 137-224,
      your graph will occupy the band of he total
      graphing area starting 20% from it's bottom to
      50% from it's bottom. If iTemp goes outside the
      predicted range, the system won't "break", but
      your graph will be outside of the planned band.
      In extreme cases, when iTmp produces a value that
      is above or below the top or bottom of the graphing
      area, the plot line will wrap. A too low value will
      give rise to a set pixel near the top of the screen,
      and vice versa.
   200,120,0 define the color the graph line will be drawn
      in. (Each can be as high as 255, and give red,
      green and blue.)

 Delay and extRemap are generally useful subroutines.
      Delay provides a non-blocking delay.
      extRemap remaps a number from it's place in one
         range to the corresponding number in a
         second range.
 If you use iDGToolYScale, you won't need to think
      about extRemap, but it will need to be in your
      code... it is a key element used inside of
      iDGToolYScale.

      (Note to self: Do a tutorial for these last two,
       each on it's own) *)

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls,Clipbrd;

const //The following determine things that
      //appear in the app's title bar, and
      //what appears on the app's icon.
      constAppName='LT2N_DrawTools_B';
      constVers='23 Dec 2018, 19:30';
      constTextForIcon='DrawTools_B';

      iDGToolImgLeft=10;
      iDGToolImgTop=50;
      iDGToolImgWidth=250;
      iDGToolImgHeight=150;

type

  { TLT2N_DrawTools_bF1 }

  TLT2N_DrawTools_bF1 = class(TForm)
    buClearDrawingArea: TButton;
    buDemoDrawGraphs: TButton;
    buLineAndDotDemo: TButton;
    buSimpleLineTest: TButton;
    buLinesNearTop: TButton;
    buDotsNearTopTest: TButton;
    buLineOfDots: TButton;
    buScrollDemo: TButton;
    buSnow: TButton;
    laParamTxt0: TLabel;
    laParamTxt1: TLabel;
    laParamTxt2: TLabel;
    laParamTxt3: TLabel;
    laTxtButtonsGuide3: TLabel;
    laYScaleHelp: TButton;
    buQuit: TButton;
    buWebLink: TButton;
    buYScaling: TButton;
    buTestScroll: TButton;
    eParam0: TEdit;
    eParam1: TEdit;
    eParam2: TEdit;
    eParam3: TEdit;
    laTxtButtonsGuide1: TLabel;
    laTxtButtonsGuide2: TLabel;
    laTxtButtonsGuide: TLabel;
    imgDGTool: TImage;
    laTitleEtc: TLabel;
    meTestDGTools: TMemo;
    Panel1: TPanel;
    procedure buScrollDemoClick(Sender: TObject);
    procedure buClearDrawingAreaClick(Sender: TObject);
    procedure buDemoDrawGraphsClick(Sender: TObject);
    procedure buLineOfDotsClick(Sender: TObject);
    procedure buLinesNearTopClick(Sender: TObject);
    procedure buDotsNearTopTestClick(Sender: TObject);
    procedure buSimpleLineTestClick(Sender: TObject);
    procedure buLineAndDotDemoClick(Sender: TObject);
    procedure buSnowClick(Sender: TObject);
    procedure buWebLinkClick(Sender: TObject);
    procedure buYScalingClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure buTestScrollClick(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure laYScaleHelpClick(Sender: TObject);

  private
    { private declarations }
    bmDGTool:TBitmap;
    clDGToolGraphBackGround:TColor;

    //Were part of DGTools_a
    //See http://sheepdogguides.com/lut/lt2n-drawtools.htm
    procedure DGToolDrawLine(iX1,iY1,
            iX2,iY2:integer;clInk:TColor);
    procedure DGToolDoDotWWr(iX1,iY1
     :integer;clInk:TColor);

    //New in DGTools_b...
    procedure DGToolScrollLeft;
    procedure DGToolClearDrawingArea;
    function iDGToolYScale(extRaw:extended;
       iRawMin,iRawMax:integer;
       iUseMin,iUseMax:byte):integer;

    //Special... should get tutorials of their own.
    function extRemap(extInput:extended;
        iSourceMin,iSourceMax,
        iOutMin,iOutMax:integer):extended;
    procedure Delay(dwMilliSeconds: DWORD);

    //Demos...
    procedure DemoBuildFrmRt;
    procedure DemoYScaling;
    procedure DemoDrawingGraphs;//Started life as
       //demo of CRUDE scaling. Evolved into
       //something doing it RIGHT!....
       //....The early
       //stages can
       //  -- CAN THEY? Pt 1 or Pt 2?...
       //be seen in the tutorial which
       //goes with this code.

  public
    { public declarations }

  end;// Creation of type TLT2N_DrawTools_bF1

var
  LT2N_DrawTools_bF1: TLT2N_DrawTools_bF1;

implementation

{$R *.lfm}

{ TLT2N_DrawTools_bF1 }

//CONSIDER IF THIS IS ACCURATE, EASY TO USE, EXPORT,
//and clear out duplications within the following and
//elsewhere...

//To use the tools here, you will need to
// copy/paste some of what's here to your
// app. (Sorry, no portable unit avail...
// yet. The work to do such things in the
// past has not garnered any expressed
// interest/ appreciation.

//The easy thing would be to open this file
// (the .pas file) in a text editor, and
// go back and forth between that and your
// growing app.

//At a minimum, you need....
// (It will probably be best to change your
//  code to match these object, variable, and
//  constant names, rather than trying to
//  change this code to match what's
//  in your app.)

//You'll need, in your app's main form:
//    An image object named imgDGTool

//Declared as global constants... you may
//  wish to change the values assigned...
//    iDGToolImgLeft=10;
//    iDGToolImgTop=30;
//    iDGToolImgWidth=200;
//    iDGToolImgHeight=150;

//Declared within the global class for
//  the main form...
//    clDGToolGraphBackGround:TColor;


//You'll need, in the main form's
//   OnCreate event handler...

(*bmDGTool:=TBitmap.create;//Explained in
     // http://sheepdogguides.com/lut/lt1Graphics.htm
  bmDGTool.width:=iDGToolImgWidth;
  bmDGTool.height:=iDGToolImgHeight;

  //The next three give you a background in the color of
  //your choice.
  // (Leave them out, and you will get a BLACK background,
  // unlike what happens in Delphi, which gives a white
  // background by default.)
  clDGToolGraphBackGround:=clWhite;//This will be referenced
     //at other places in the program.
  bmDGTool.canvas.pen.color:=clDGToolGraphBackGround;
  bmDGTool.canvas.rectangle(0,0,iDGToolImgWidth,iDGToolImgHeight);

  imgDGTool.picture.graphic:=bmDGTool;

  imgDGTool.left:=iDGToolImgLeft;
  imgDGTool.top:=iDGToolImgTop;
  imgDGTool.width:=iDGToolImgWidth;
  imgDGTool.height:=iDGToolImgHeight;

-------------------------------------------------
You'll also need the subroutines that follow,
down to where you see the note...

//Below here... just the "stuff" needed to
//  demonstrate...

In importing those, you will need to change
   the "TLT2N_DrawTools_bF1." of each.

*** AFTER all of the above is taken care of,
**Start the "importing routines" exercise with...
       DGToolDrawLine
That doesn't depend on other routines, and
   you can get on top of all the importing
   niggles, before having lots of lose ends.

You will also have to do the forward
   declarations for them in the interface
   part of your code.

The following should be a complete list, in
   the order the routines appear below.
   Please get in touch if there are errors
   in either the completeness of the list,
   or it's ordering?
   Details at
http://sheepdogguides.com/lut/lt26n-drawtools-pt2.htm
(please mention that URL when writing)

procedure DGToolDrawLine(iX1,iY1,
            iX2,iY2:integer;clInk:TColor);

procedure DGToolDoDotWWr(iX1,iY1
     :integer;clInk:TColor);

procedure DGToolScrollLeft;

procedure DGToolClearDrawingArea;
    function iDGToolYScale(extRaw:extended;
       iRawMin,iRawMax:integer;
       iUseMin,iUseMax:byte):integer;

function iDGToolYScale(extRaw:extended;
   iRawMin,iRawMax:integer;
   iUseMin,iUseMax:byte):integer;

function extRemap(extInput:extended;
        iSourceMin,iSourceMax,
        iOutMin,iOutMax:integer):extended;

procedure Delay(dwMilliSeconds: DWORD);

*)

procedure TLT2N_DrawTools_bF1.
   DGToolDrawLine(iX1,iY1,
             iX2,iY2:integer;clInk:TColor);
  begin
    imgDGTool.canvas.pen.color:=clInk;
    imgDGTool.picture.bitmap.canvas.moveto(iX1,iY1);
    imgDGTool.picture.bitmap.canvas.lineto(iX2,iY2);
  end; //DGToolDrawLine

procedure TLT2N_DrawTools_bF1.
   DGToolDoDotWWr(iX1,iY1
     :integer;clInk:TColor);
//vers 23 Dec 2018
//TOOLS_B version... improved.. twice...
//over "original original" in
//  Tools_a. This wraps if values
//  of iY1 become negative. (Tools_a may
//  have been upgraded to this by the time
//  you are reading these comments... or may
//  still exist in the early, flawed,
//  "mostly works" form it was originally
//  published in)
  begin
    //Next two: New since 1Dec18
    iX1:=iX1 mod iDGToolImgWidth;
    while (iX1<0) do iX1:=iX1+iDGToolImgWidth;

    iY1:=iY1 mod iDGToolImgHeight;//REVISED
    while (iY1<0) do iY1:=iY1+iDGToolImgHeight;

    imgDGTool.picture.bitmap.
      canvas.pixels[iX1,iY1]:=clInk;//REVISED
  end; //DGToolDrawLineWWr

procedure TLT2N_DrawTools_bF1.
   DGToolScrollLeft;
var rectSource,rectDest:TRect;
begin
  //First: Copy all but first column one place to the left.
  rectSource:=Rect(1,0,iDGToolImgWidth,iDGToolImgHeight);
  rectDest:=Rect(0,0,iDGToolImgWidth-1,iDGToolImgHeight);
  imgDGTool.picture.bitmap.
      canvas.CopyRect(rectDest,imgDGTool.picture.bitmap.
      canvas,rectSource);

  //Then: Erase right hand column to backgorund color
  imgDGTool.canvas.pen.color:=clDGToolGraphBackGround;
  imgDGTool.picture.bitmap.
      canvas.moveto(iDGToolImgWidth-1,0);
  imgDGTool.picture.bitmap.
      canvas.lineto(iDGToolImgWidth-1,iDGToolImgHeight);
  //In prev: Definitely NOT "-1" on iDGToolImgHeight
  //  (Because it is lineTO??)
end;//DGToolScrollLeft;

procedure TLT2N_DrawTools_bF1.
   DGToolClearDrawingArea;
//Sets all pixels in drawing area to
//whatever color is specified by the value in
//the global clDGToolGraphBackGround;(TColor)

//Note that there is a slight differnce between
//how Delphi and Lazarus initialize things...
//The TImage object? The Bitmap? The picture?
//canvas? Something like that! THIS works with
//Lazarus, and would with Delphi, too, I think.
//Delphi people can get away with not
//initializing something. Note I said "Get away
//with"... always a bad thing to lean on
//in programming.
begin
  //Pen, brush: One is outline, other is fill...
  imgDGTool.canvas.brush.color:=clDGToolGraphBackGround;
  imgDGTool.canvas.pen.color:=clDGToolGraphBackGround;

  imgDGTool.picture.bitmap.
      canvas.rectangle(0,0,iDGToolImgWidth,iDGToolImgHeight);
  //Last two terms tested for fencepost errors... to re-
  //  test, set brush to black, pen to red
end;//DGToolClearDrawingArea;

//An important "helper" function...
function TLT2N_DrawTools_bF1.
   iDGToolYScale(extRaw:extended;
     iRawMin,iRawMax:integer;
     iUseMin,iUseMax:byte):integer;
//Makes reference to some global constants:
//  (list)
//This is primarily a service routine for
//  DGToolDoDotWWr.
//Takes iRaw, and converts it to a value suitable
//  for use as a Y value for plotting a pixel on
//  graph.
//"Suitable" includes inverting things, so big
//  numbers are high on the cartesian plane,
//  low numbers are towards bottom.
//iRawMin, iRawMax should hold the minimum and
//  maximum values expected for the raw data.
//  (These should be INCLUSIVE of range expected... ARE THEY?
//(Are negatives allowed?? Inversion (i.e. iRawMin > iRawMax)
//  If the actual data exceeds any expectations,
//    the resulting dots may be above or below
//    the band of the graph specified by iUseMin,
//    iUseMax. The worst thing that can happens
//    is that data will "wrap", vertically. You
//    will be saved by the "out of range"
//    provisions in DGToolDoDotWWr.
//iUseMin, iUseMax specify where the data should
//  appear, vertically, on the graph. If 0 and 99
//  respectively, iRawMin should plot at bottom
//  of graph, iRawMax should plot at top.
//  In other words, they are expressed in percents.
//  Due to rounding errors, etc, these may not
//     be where you will always find them, exactly.
//  ... or they may not be exactly where planned due
//  ... to problems with the details of the programming
//  ... Tests of "boundary cases" are still needed. In
//  ... particular, check that no datum will go unseen,
//  ... i.e. be "off edge of page".
var iTmp:integer;
    extFactor:extended;
begin
 //Supply iUseMin and iUseMax with 60 and 69
 //   if iRawMin should plot 60% up the graphing
 //   area, and  iRawMax should plot 69% UP the graphing
 //   area. The routine returns the coordinate,
 //   as needed for the standard Lazarus "Pixel", so
 //   before we do anything else, we will convert the
 //   "percents" to coordinate values.
 //Example... if 50, 60 were passed when iDGToolImgHeight
 //   were 200, then they should be changed to 100 and 120.
 //   (There may be one or more "-1"s needed somewhere
//     here. Sigh.

 //First check if user has inverted the raw range spec, and
 //  fix, if so.
 if iRawMin>iRawMax then begin
    iTmp:=iRawMin;
    iRawMin:=iRawMax;
    iRawMax:=iTmp;
    end;
 extFactor:=(iDGToolImgHeight-1)/100;
 iUseMin:=trunc(iUseMin*extFactor);//trunc, not round, on purpose!
 iUseMax:=trunc(iUseMax*extFactor);

 extRaw:=extRemap(extRaw,iRawMin,iRawMax,
            iUseMin,iUseMax);

 iTmp:=Round(extRaw);
 //"iRaw" is no lnoger the "raw" number we had when
 //we entered this routine. It has been converted
 //to more useable value.

 //and finally "invert" the value...
 //   Up 'til now we've been working as it the
 //   graph origen (0,0) is at TOP of page, as
 //   indeed it is in the Lazarus (and Delphi)
 //   world. We want low numbers to print LOW
 //   in the graph, not high... and this achieves
 //   that.
 result:=iDGToolImgHeight-1-iTmp;
end;//iDGToolYScale

//===================================
//An important "helper" function, and useful in
//  many contexts, not just these Drawing Tools
function TLT2N_DrawTools_bF1.
    extRemap(extInput:extended;
        iSourceMin,iSourceMax,
        iOutMin,iOutMax:integer):extended;
//This is used inside iDGToolYScale
//
//I have not yet investigated what happens
//   if you have negative numbers anywhere.
//Nor what happens if you spec, say...
//    123, 50, 150, 500, 400
// (123: to be shifted and scaled,
//    50 to 150: Range that 123 will be in
//    500 to 400, the range you want it
//    remapped to. If the function can be
//    made tolerant of such inputs, then as
//    the input (123) rises, the output would
//    fall. And vice versa. Sho8uld be possible.
//    But I haven't tested for that yet.

//While some of the numbers you will want to
//  shift will have fractional parts, you must
//  specify the range of what you start from
//  with integers. So, if the input could range,
//  say, from 3.5 to 7.8, declare the source
//  range as from 2 to 8. (The numbers spec'd
//  are treated as part of the range.)
//Likewise, you must specify the range they
//  will map to with integers. You want the
//  results to run from 76.3 to 95.2? Specify
//  75 to 96.

//In the following names, "have" refers to the
// numbers you "have" before you do the shift
// and scale.
//"Wanted" refers to the numbers you want after
//   tbe shifting and scaling.

var iShiftWantedsToZero,iShiftHavesToZero:integer;
    extScaleFactor:extended;
begin
 iShiftWantedsToZero:=iOutMin;//**1
 iShiftHavesToZero:=iSourceMin;//**2

 extScaleFactor:=(iSourceMax-iShiftHavesToZero)/
                 (iOutMax-iShiftWantedsToZero);//**3

 extInput:=(extInput-iShiftHavesToZero)/extScaleFactor;//**4

 result:=extInput+iShiftWantedsToZero;//**5
end;//extRemap

procedure TLT2N_DrawTools_bF1.
   Delay(dwMilliSeconds: DWORD);
//Copied from third reply in https://forum.lazarus.
//   freepascal.org/index.php?topic=40760.0
//Creates non-blocking delay of about AMilliseconds
var
  dwTmp: DWORD;
begin
  dwTmp := GetTickCount + dwMilliSeconds;//Note:
  //if overflow occurs, it won't matter, I think
  //The problem CAN be solved... Have I done it here?
  //The problem would arise if this were called with
  //dwMilliseonds = to, say, 1000, when GetTickCount
  //was less than 1000 "ticks" from the maximum
  //number that function can return. The solution
  //lies in the fact that
  //the value returned by GetTickCount ALSO rolls
  //over. (There may be issues with RangeChecking
  //throwing up a warning... this bridge can be
  //crossed if we get to it. Sigh.
  while (GetTickCount < dwTmp) and
     (not Application.Terminated) do
        Application.ProcessMessages;
end;//Delay

//========================================================
// - - - - - - - - -
//Below here... just the "stuff" needed to
//  demonstrate use of the above.
//Please let me know, save the next person, if there are
//  on the wrong side of this line.

procedure TLT2N_DrawTools_bF1.FormCreate(Sender: TObject);
begin
  randomize;//So we don't get the same sequence of "random"
     //numbers every time the program runs.
     //It sometimes pays to rem that out, if doing testing.

  meTestDGTools.lines.clear;

  bmDGTool:=TBitmap.create;//Explained in
     // http://sheepdogguides.com/lut/lt1Graphics.htm
  bmDGTool.width:=iDGToolImgWidth;
  bmDGTool.height:=iDGToolImgHeight;

  //The next three give you a background in the color of
  //your choice.
  // (Leave them out, and you will get a BLACK background,
  // unlike what happens in Delphi, which gives a white
  // background by default.)
  clDGToolGraphBackGround:=clWhite;//This will be referenced
     //at other places in the program.
  bmDGTool.canvas.pen.color:=clDGToolGraphBackGround;
  bmDGTool.canvas.rectangle(0,0,iDGToolImgWidth,iDGToolImgHeight);

  imgDGTool.picture.graphic:=bmDGTool;

  imgDGTool.left:=iDGToolImgLeft;
  imgDGTool.top:=iDGToolImgTop;
  imgDGTool.width:=iDGToolImgWidth;
  imgDGTool.height:=iDGToolImgHeight;

  //A little trick to put the running app
  //  someplace other than on top of the "design"
  //  copy of the app's window.
  LT2N_DrawTools_bF1.left:=150;
  LT2N_DrawTools_bF1.top:=64;

  application.title:=constTextForIcon;
  LT2N_DrawTools_bF1.caption:=constAppName+', vers '+constVers;

  buWebLink.caption:='Click to copy to clipboard: '+
     'http://sheepdogguides.com/lut/lt2n-drawtools-pt2.htm';

  eParam0.text:='100';
  eParam1.text:='150';
  eParam2.text:='50';
  eParam3.text:='90';

end;//FormCreate



//Here begins a block of button OnClick Handlers. Most just
//  call a subroutine with an allied name.

procedure TLT2N_DrawTools_bF1.buTestScrollClick(Sender: TObject);
begin
  DGToolScrollLeft;
end;

procedure TLT2N_DrawTools_bF1.buQuitClick(Sender: TObject);
begin
  close;//Is tjhis best way to quit?
end;

procedure TLT2N_DrawTools_bF1.laYScaleHelpClick(Sender: TObject);
begin
  showmessage('The YScaling button tests '+
   'the "iDGToolYScale"'+
   //{(iRawValue,iParam0,iParam1,iParam2,iParam3),    '}
   'tool. '+
   'It uses that function to plot some dots, across '+
   'the range spec''d by P0, P1, and in the band '+
   'P2 to P3. The "band" sets the limits of the dots '+
   'the dots drawn.... 10, 50 puts the dots (at or?) '+
   '10% up the graph and 50% up the graph.');
end;

procedure TLT2N_DrawTools_bF1.buLineAndDotDemoClick(Sender: TObject);
begin
  imgDGTool.canvas.pen.color:=clBlue;
  imgDGTool.picture.bitmap.canvas.moveto(5,20);
  imgDGTool.picture.bitmap.canvas.lineto(10,40);

  //And do a dot in lower right hand corner, to show the
  //  coordinates used for that. Note the "-1"s...
  imgDGTool.picture.bitmap.canvas.
       pixels[iDGToolImgWidth-1,iDGToolImgHeight-1]:=clGreen;
end;

procedure TLT2N_DrawTools_bF1.buSnowClick(Sender: TObject);
var c1:integer;
begin
for c1:=0 to 500 do
 DGToolDoDotWWr(random(iDGToolImgWidth),random(iDGToolImgHeight),clGreen);
end;

procedure TLT2N_DrawTools_bF1.buWebLinkClick(Sender: TObject);
begin
  Clipboard.Clear; // requires Clipbrd in
    //Uses clause. See http://sheepdogguides.com/lut/lt1Ne.htm
  Clipboard.AsText:='http://sheepdogguides.com/lut/lt2n-drawtools-pt2.htm';
end;

procedure TLT2N_DrawTools_bF1.buYScalingClick(Sender: TObject);
begin
  DemoYScaling;
end;

procedure TLT2N_DrawTools_bF1.buSimpleLineTestClick(Sender: TObject);
  begin
    DGToolDrawLine(10,25,40,20,clRed);
  end; //buTestClick

procedure TLT2N_DrawTools_bF1.buLineOfDotsClick(Sender: TObject);
var xTmp, yTmp:integer;
begin
  xTmp:=10;
  for yTmp:=10 to 200 do begin
    DGToolDoDotWWr(xTmp,yTmp,clRed);
    xTmp:=xTmp+1;
    delay(20);
  end;// of for...
end;// of  buLineOfDotsClick

procedure TLT2N_DrawTools_bF1.buScrollDemoClick(Sender: TObject);
begin
  DemoBuildFrmRt;
end;

procedure TLT2N_DrawTools_bF1.buClearDrawingAreaClick(Sender: TObject);
begin
  DGToolClearDrawingArea;
end;

procedure TLT2N_DrawTools_bF1.buDemoDrawGraphsClick(Sender: TObject);
begin
  DemoDrawingGraphs;
end;

procedure TLT2N_DrawTools_bF1.buLinesNearTopClick(Sender: TObject);
begin
  DGToolDrawLine(10,0,30,0,clRed);
  DGToolDrawLine(30,1,50,1,clGreen);
  DGToolDrawLine(50,2,70,2,clBlue);
  DGToolDrawLine(70,1,90,1,clGreen);
  DGToolDrawLine(90,0,110,0,clRed);
end;//buText3Click

procedure TLT2N_DrawTools_bF1.buDotsNearTopTestClick(Sender: TObject);
begin
  DGToolDoDotWWr(10,10,clRed);
  DGToolDoDotWWr(30,21,clGreen);
  DGToolDoDotWWr(50,32,clBlue);
  DGToolDoDotWWr(70,21,clGreen);
  DGToolDoDotWWr(90,10,clRed);
end;//buTest4Click

//Below here demo routines. (Mostly just things called by
// the OnClick handler for various buttons.

procedure TLT2N_DrawTools_bF1.DemoBuildFrmRt;
//(a demo routine)
var iY, iCount:integer;
begin
  for iCount:=0 to 70 do begin
    DGToolScrollLeft;
    iY:=10+(iCount mod 30);//Goes 10,11,12...38,39,10, 11...
    DGToolDoDotWWr(iDGToolImgWidth-1,iY,clRed);
    Delay(40);
  end;//for
end;//BuildFrmRt; (a demo of a trick)

procedure TLT2N_DrawTools_bF1.DemoYScaling;
var iCount,iRawValue:integer;
  iParam0,iParam1,iParam2,iParam3:integer;
  boRawMinMoreThanRawMax:boolean;
  //A complex demo of iDGToolYScale...
  //  interactive via eParam0, etc...

begin
  //Yes... I SHOULD do something "clever",
  // so that we don't have nearly the
  // same code four times. Sigh.
  //Should alert user if an invalid
  // entry changed to zero.
  try iParam0:=strtoint(eParam0.text);
  except
    on E:EConvertError do begin
    eParam0.text:='0';
    iParam0:=0;
    end;//do on EConvert
  end;//try--- 0
  try iParam1:=strtoint(eParam1.text);
  except
    on E:EConvertError do begin
    eParam1.text:='0';
    iParam1:=0;
    end;//do on EConvert
  end;//try--- 1
  try iParam2:=strtoint(eParam2.text);
  except
    on E:EConvertError do begin
    eParam2.text:='0';
    iParam2:=0;
    end;//do on EConvert
  end;//try--- 2
  try iParam3:=strtoint(eParam3.text);
  except
    on E:EConvertError do begin
    eParam3.text:='0';
    iParam3:=0;
    end;//do on EConvert
  end;//try--- 3

  //Demo and iDGToolYScale can cope, if user
  //has a iRawMin that is > iRawMax.
  //Demo will do from iRawMin down to iRawMax.
  //iDGToolYScale swtiches them around, internally,
  //   is thereby unaffected.

  boRawMinMoreThanRawMax:=false;
  iRawValue:=iParam0;
  if iParam0>iParam1 then begin
      boRawMinMoreThanRawMax:=true;
      iRawValue:=iParam1;
      end;//if iParam0>iParam1

  for iCount:=0 to 200 do begin
      DGToolDoDotWWr(iCount,
          iDGToolYScale(iRawValue,iParam0,iParam1,iParam2,iParam3),
          clTeal);
      //Prepare next...
      if boRawMinMoreThanRawMax then begin
         iRawValue:=iRawValue-1;
         if iRawValue<iParam1 then iRawValue:=iParam0;
         end//then... no ; here
       else begin
         iRawValue:=iRawValue+1;
         if iRawValue>iParam1 then iRawValue:=iParam0;
         end;//else
  end;//for iCount..
end;//DemoYScaling;

procedure TLT2N_DrawTools_bF1.DemoDrawingGraphs;
//Demo of drawing some graphs
//
//The HEART of this is the call to DGToolDoDotWWr. Most of
//  the rest is there to make it happen many times, and to
//  provide a "virtual sensor" returning wandering readings
var bDrift,bCount:byte;//(0-255)
    boDirectionUp:boolean;//Sets which way readings drift
                      //for the moment. Can change.
    iTmp,iCount,iSensor:integer;//(positive AND negative
                      // numbers in the range allowed.)

function iFakedSensor(iLo,iHi:integer):integer;
  //Uses several shared variables. Bad practice!
  begin
    //From time to time, change direction of
    //  drift
    if (random(10)=0) then boDirectionUp:=
       not boDirectionUp;

    //From time to time, change size of drift
    if (random(8)=0) then begin
       bDrift:=random(3);
       end;//change size of drift.

    //Apply drift to previous sensor reading
    if boDirectionUp then
        iSensor:=iSensor+bDrift//no ; here
       else
        iSensor:=iSensor-bDrift;

    //Clip, if value has gone beyond
    //  the (arbitrary) bonds required of
    //  this routine's design parameters
    if (iSensor>iHi) then begin
       iSensor:=iHi;
       boDirectionUp:=false;
       end;

    if (iSensor<iLo) then begin
       iSensor:=iLo;
       boDirectionUp:=true;
       end;

    result:=iSensor;
  end;//iFakedSensor

begin// main block of DemoDrawingGraphs
//From here...
iSensor:=115;//Initial value from sensor.
bDrift:=2;
boDirectionUp:=true;
//... to here: Just setting up the sensor reading faker.

//Now read sensor, plot (twice) at right edge, scroll...
//   many times. (You can exit program even while it
//   is in the loop.)
for iCount:=0 to 1250 do begin
   iTmp:=iFakedSensor(24,264);
    meTestDGTools.lines.add(inttostr(iTmp));

    DGToolDoDotWWr(iDGToolImgWidth-1,
       iDGToolYScale(iTmp,
                     24,264,5,70),clLime);
    //... and plot the graph again... it could
    //  be a different one... in a different
    //  band of the drawing area, in a different
    //  color, scaled differently!
    DGToolDoDotWWr(iDGToolImgWidth-1,
       iDGToolYScale(iTmp,
                     24,264,75,98),RGBToColor(200,120,0));

    //Because of how iFakedSensor works, the range of
    //  sensor "readings" stayed between 24 and 264
    //  during testing, and thus my graph stayed between
    //  the boundaries I had specified. There is no
    //  guarantee that the sensor readings will do
    //  this for you if you have a "randomize" in
    //  FormCreate. Or even if you don't, and you
    //  change other things.
    DGToolScrollLeft;

    Delay(4);
    end;//for...
end;//DemoDrawingGraphs

end.

